#ifndef EXHIBIT_H_
#define EXHIBIT_H_

#include <gmath/gmath.h>
#include "object.h"
#include "geom.h"

class Exhibit;
class ExhibitPriv;

enum {
	EXSEL_RAY = 1,
	EXSEL_SPHERE = 2
};

class ExSelection {
public:
	Exhibit *ex;
	void *obj;
	void *data;
	Ray selray;
	Sphere selsphere;
	unsigned int validmask;

	ExSelection(Exhibit *ex = 0);

	operator bool() const;
};

/* TODO
- select me aktina kai select me sfaira, epistrefei Selection
- hover me aktina kai hover me sfaira
- move me selection, origin, direction kai rotation (?)
 */
class Exhibit : public Object {
private:
	ExhibitPriv *priv;

public:
	Exhibit();
	virtual ~Exhibit();

	Exhibit(const Exhibit&) = delete;
	Exhibit &operator =(const Exhibit &) = delete;

	virtual ExSelection select(const Ray &ray) const;
	virtual ExSelection select(const Sphere &sph) const;

	virtual void update(float dt = 0.0f);

	virtual void pre_draw() const;
	virtual void draw() const;
	virtual void post_draw() const;
};

#endif	// EXHIBIT_H_
