#ifndef METASCENE_H_
#define METASCENE_H_

#include <map>
#include "scene.h"
#include "mesh.h"
#include "datamap.h"

class MetaScene {
public:
	DataMap datamap;

	std::vector<Scene*> scenes;

	Mesh *walk_mesh;
	Vec3 start_pos;
	Quat start_rot;

	std::map<Scene*, void*> scndata;


	MetaScene();
	~MetaScene();

	bool load(const char *fname);
	bool scene_loaded(Scene *scn);

	void update(float dt);
	void draw() const;
};

#endif	// METASCENE_H_
